=== documentation/Makefile ===
# Makefile for documentation
# 
# See README-authors for more information.

.SUFFIXES:

-include ../config
-include Makefile.docs

# whether documentation should be installed in subdirs;
# see install-langs target
INSTALLSTYLE	?= subdir

# fdisk documentation to include (varies per platform)
FDISK_DOCS := $(shell grep -s "fdisk\|fdasd\|dasdfmt\|parted" \
		../scripts/rootdisk/SMALL_BASE_LIST_$(architecture) | \
		sed -e 's/^.*\/\(.*\)/\1.txt/' 2>/dev/null)

# set extension of source/dest files based on LINGUA
ifeq ($(LINGUA),C)
SRCEXT		:=
DESTEXT		:= .en
DESTDIRADD	:=
else
SRCEXT		:= .$(LINGUA)
DESTEXT		:= .$(LINGUA)
DESTDIRADD	:= $(LINGUA)
endif

# programs for creating output
DDOC		:= /usr/share/sgml/debiandoc/dtd/sgml/1.0/debiandoc.dcl
DEBIANDOC2HTML	:= debiandoc2html -d $(DDOC) -l $(LINGUA) -c 
DEBIANDOC2PS	:= debiandoc2ps -d $(DDOC) -l $(LINGUA)
DEBIANDOC2TEXT	:= debiandoc2text -d $(DDOC) -l $(LINGUA) 
DEBIANDOC2LATEX	:= debiandoc2latex -d $(DDOC) -l $(LINGUA)

# detailed sgml validation
NSGMLS		:= nsgmls -ges -wall $(DDOC)

# maximum times we're willing to run TeX to get cross-references right, if you subtract by 3
MAX_TEX_RECURSION	:= 6

# documents to build
TARGETDOCS := index.en.html			\
	      install$(DESTEXT).txt		\
	      install$(SRCEXT).html/install$(DESTEXT).html \
	      $(FDISK_DOCS)

ifneq "$(findstring $(LINGUA),$(dselect-beginner-langs))" ""
TARGETDOCS += dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html \
	      dselect-beginner$(DESTEXT).txt
endif

# you might want to remove this if it is failing for you
#   ja and ru documents are currently not converted into .pdf correctly 
ifneq ($(LINGUA),ja)
ifneq ($(LINGUA),ru)
TARGETDOCS	+= install$(DESTEXT).pdf
endif
endif

EXTRAFILES	:= officiallogo-nd-50.jpg openlogo-nd-50.jpg

# just an unreasonable default
DESTDIR		:= /tmp

ifeq ($(OFFICIALWEBBUILD),true)
# special build requirements for web building
install_file 	:= install -m 2664 -p
makedir		:= mkdir -m 2775
else
install_file	:= install -m 644 -p
makedir		:= mkdir -m 0755
endif

DEB_VERSION	:= $(shell cd .. && LC_ALL=C dpkg-parsechangelog |	\
			grep '^Version: ' | sed 's/^Version: *//')

# default date representation in documents
DATEFORM_$(LINGUA) := %d %B, %Y
# exceptions from the above rule:
DATEFORM_hr	:= %-d. %-m. %Y.
DATEFORM_de	:= %-d. %b. %Y

DATE		:= $(shell cd .. && date --date="`dpkg-parsechangelog |	\
			grep '^Date: ' | sed 's/^Date: *//'`" 		\
			'+$(strip $(DATEFORM_$(LINGUA)))')

# derived entity files
DERIVED_ENTS	:= messages.ent dynamic.ent
# this for is used for dependencies
ENT_DEPENDS	:= defaults.ent messages.ent dynamic.ent

define checklingua
  if [ -z "$(LINGUA)" ]; then \
  echo LINGUA variable is not set -- see documentation/README-authors; \
  exit 1; \
  fi
endef

# actual rules start here
# (note: default rule is the default one from Makefile.docs, not this one)
.PHONY:	all
all:	supplemental_makefile $(TARGETDOCS) $(EXTRATARGETDOCS)

.PHONY: lint
lint:	$(ENT_DEPENDS)
ifneq "$(wildcard install$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for Installation Manual, language $(LINGUA):"
	$(NSGMLS) install$(SRCEXT).sgml
#	@echo "Checking for deprecated entity references:"
#	nsgmls -oentity /usr/lib/sgml/declaration/debiandoc.decl \
#	  install$(SRCEXT).sgml 2>/dev/null | sed -e '/^IMSG/!d' -e 's/^I/   /'
endif
ifneq "$(wildcard dselect-beginner$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for dselect Documentation for Beginners, language $(LINGUA):"
	$(NSGMLS) dselect-beginner$(SRCEXT).sgml
endif
ifneq "$(wildcard release-notes$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for Release Notes, language $(LINGUA):"
	$(NSGMLS) release-notes$(SRCEXT).sgml
endif

.PHONY:	validate
validate:	$(ENT_DEPENDS)
	@set -ex; for i in *.sgml; do $(NSGMLS) $$i; done

.PHONY:	supplemental_makefile
supplemental_makefile:
	@$(checklingua)
	@[ ! -f $(LINGUA)/Makefile ] || $(MAKE) -C $(LINGUA)

# generate the nice index page.
# FIXME: is m4 really the right way to do this?
ifneq "$(wildcard index$(DESTEXT).html.m4)" ""
index$(DESTEXT).html: index$(DESTEXT).html.m4; m4 \
 --define=ARCHITECTURE=${architecture} \
 --define=OFFICIAL=${OFFICIALWEBBUILD} \
    $< > $@
else
.PHONY: index$(DESTEXT).html index.en.html
endif

# this will probably only work if your name is "Adam Di Carlo"
.PHONY: ChangeLog
ChangeLog:
	cvs2cl.pl --tags --branches --revisions --utc	\
	  --usermap $$HOME/debian/boot-floppies/CVSROOT/users

# generic rules for all the languages and output formats -- Installation Manual.
ifneq "$(wildcard install$(SRCEXT).sgml)" ""
install$(SRCEXT).html/install$(DESTEXT).html:	install$(SRCEXT).sgml	\
						$(ENT_DEPENDS)
	$(DEBIANDOC2HTML) -t install $<

install$(DESTEXT).txt:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2TEXT) -O $< > $@

install$(DESTEXT).ps:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2PS) -O $< > $@

install$(DESTEXT).tex:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2LATEX) -O $< > $@
else
.PHONY: install$(SRCEXT).html/install$(DESTEXT).html install$(DESTEXT).txt \
        install$(DESTEXT).ps install$(DESTEXT).tex install$(DESTEXT).pdf
endif

# generic rule for all the PDFs
%.pdf:	%.tex
#	 note that I have seen bi-stable .aux files, thus we check two levels deep
	-cp -pf prior.aux pprior.aux 2>/dev/null
	-cp -pf $(basename $<).aux prior.aux 2>/dev/null
#	 fail if we don't have pdflatex correctly installed
	kpsewhich pdflatex.fmt >/dev/null
#	 due to a bug in debiandoc2latex2e output, this might fail
	-pdflatex '\nonstopmode\input{$<}' >/dev/null # see $(@:.pdf=.log) for details
	@set -e								;\
	if ! cmp $(basename $<).aux prior.aux 2>/dev/null &&		\
	   ! cmp $(basename $<).aux pprior.aux 2>/dev/null; then	\
		if expr $(MAKELEVEL) '<' $(MAX_TEX_RECURSION) >/dev/null;\
		then							\
		   echo "remaking $@ (take $(MAKELEVEL))"		;\
		   rm -f $@						;\
		   $(MAKE) $@						;\
		else							\
		   echo "E: $@ needs remaking, but we have reached max. level, $(MAX_TEX_RECURSION)" ;\
		fi							\
	fi
	rm -f prior.aux pprior.aux

# generic rules for all the languages and output formats -- dselect Documentation for Beginners
ifneq "$(wildcard dselect-beginner$(SRCEXT).sgml)" ""
dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html:		\
		dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2HTML) -t dselect-beginner $<

dselect-beginner$(DESTEXT).txt:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2TEXT) -O $< > $@

dselect-beginner$(DESTEXT).ps:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2PS) $<

dselect-beginner$(DESTEXT).tex:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2LATEX) -O $< > $@
else
.PHONY: dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html \
        dselect-beginner$(DESTEXT).txt dselect-beginner$(DESTEXT).ps \
        dselect-beginner$(DESTEXT).tex dselect-beginner$(DESTEXT).pdf
endif

# these rules generate text files out of *fdisk programs' manpages
cfdisk.txt:
	./man2text $(ftp_archive) cfdisk 8 util-linux > $@

cfdisk-utf8.txt: cfdisk.txt
	cp -a cfdisk.txt cfdisk-utf8.txt

fdisk.txt:
	./man2text $(ftp_archive) fdisk 8 util-linux > $@

atari-fdisk.txt:
	./man2text $(ftp_archive) atari-fdisk 8 atari-fdisk > $@

amiga-fdisk.txt:
	./man2text $(ftp_archive) amiga-fdisk 8 amiga-fdisk > $@

mac-fdisk.txt:
	./man2text $(ftp_archive) mac-fdisk 8 mac-fdisk > $@

pmac-fdisk.txt:
	./man2text $(ftp_archive) pmac-fdisk 8 pmac-fdisk-cross > $@

dasdfmt.txt:
	./man2text $(ftp_archive) dasdfmt 8 s390-tools > $@

fdasd.txt:
	./man2text $(ftp_archive) fdasd 8 s390-tools > $@

parted.txt:
	./man2text $(ftp_archive) parted 8 parted > $@

.PHONY: install
install:
	set -e								;\
	for lang in $(installmanual-langs); do				 \
	    echo "installing $$lang"					;\
	    $(MAKE) LINGUA=$$lang install-lang				;\
	done
ifeq ($(OFFICIALWEBBUILD),true)
#	setting our nice content-negotiation symlinks
	set -e								;\
	for file in `find $(ALLARCHINSTALLDIR)/$(architecture) -name '*.en.*'`; do	 \
	    ln -sf `basename $$file` `echo $$file | sed -e 's/\.en//'`	;\
	done
endif

.PHONY:	install-lang
install-lang:
	[ -d $(DESTDIR) ] || $(makedir) -p $(DESTDIR)
ifneq ($(INSTALLSTYLE),subdir)
#	install all langs files into one directory
	$(install_file) $(TARGETDOCS) $(EXTRAFILES)			 \
		$(wildcard dselect-beginner$(SRCEXT).html/*		 \
		install$(SRCEXT).html/*) $(DESTDIR)
else		# subdirectory install, to make things easier to find
	for doc in $(TARGETDOCS) $(EXTRAFILES)				 \
		$(wildcard dselect-beginner$(SRCEXT).html/* 		 \
		install$(SRCEXT).html/*); do				 \
	    $(makedir) -p $(DESTDIR)/$(DESTDIRADD)				;\
	    $(install_file) $$doc $(DESTDIR)/$(DESTDIRADD)		;\
	done
#	make index.html symlink to index.??.html for all subdirs
	set -e								;\
	for file in `find $(DESTDIR) -name 'index.??.html'`; do		 \
	    ln -sf `basename $$file`					 \
		   `echo $$file | sed -e 's/\...\.html/.html/'`		;\
	done
endif

.PHONY:	clean
clean:
	rm -f $(DERIVED_ENTS) dynamic_*.ent messages*.ent
	rm -rf *.html
	rm -f *.txt *.tex *.dvi *.pdf *.ps
	rm -f *.log *.aux *.bak *.out *.sasp* *.toc
	rm -f doc.stamp
	set -e ; for dir in `find . -type d -mindepth 1 -maxdepth 1`; do \
	    [ ! -f $$dir/Makefile ] || $(MAKE) -C "$$dir" $@		;\
	done

.PHONY:	distclean
distclean: clean
	rm -f *~ *.orig \#*
	rm -rf $(ALLARCHINSTALLDIR)
	rm -rf upgrade-*
	rm -f relnotes.tar.bz2

##
## upload docs to http://www.debian.org/releases/...
##
# this will only work if you're in the debwww group on localhost and on www-master
mirror-to-master:
	@[ -d $(ALLARCHINSTALLDIR) ] || { echo "Run make (uni-)doc-web first!"; exit 1; }
	chgrp -R debwww $(ALLARCHINSTALLDIR)
	find $(ALLARCHINSTALLDIR) -type f | xargs chmod 0664
	find $(ALLARCHINSTALLDIR) -type d | xargs chmod g+sw
	rsync -rltDpgvz --rsh ssh $(ALLARCHINSTALLDIR)/		\
	  www-master.debian.org:/org/www.debian.org/www/releases/$(debname)/


# generate entities which are dynamically defined by the settings of this
# build run, generally set in the top-level config file
dynamic_$(LINGUA)_$(architecture).ent: ../debian/changelog
ifeq "$(architecture)" ""
	@echo architecture variable is not set -- see documentation/README-authors
	exit 1
endif
ifeq "$(findstring $(architecture), $(arches))" ""
	@echo architecture variable is set to something strange, edit ../config
	exit 1
endif
	: > $@			# clear the file
	echo "<!entity docversion       \"$(DEB_VERSION)\">" >> $@
	echo "<!entity docdate          \"$(DATE)\">" >> $@
	echo "<!entity language         \"$(LINGUA)\">" >> $@
	echo "<!entity langext          \"$(DESTEXT)\">" >> $@
	echo "<!entity release          \"$(debianversion)\">" >> $@
	echo "<!entity releasename      \"$(debname)\">" >> $@
	echo "<!entity kernelversion    \"$(kver)\">" >> $@
	echo "<!entity altkernelversion \"$(altkver)\">" >> $@
	echo "<!entity architecture     \"$(architecture)\">" >> $@
	echo "<!entity % $(architecture) \"INCLUDE\">" >> $@
	echo "<!entity % lang-$(LINGUA) \"INCLUDE\">" >> $@
	set -e; for i in $(FDISK_DOCS); do			    \
		echo "<!entity % $$i    \"INCLUDE\">" >> $@;\
	done
ifeq ($(OFFICIALWEBBUILD),true)
	echo "<!entity % official-web-build \"INCLUDE\">" >> $@
	echo "<!entity path-to-top-level \"\">" >> $@
else
	echo "<!entity % official-web-build \"IGNORE\">" >> $@
# figure out how we get to the top level, for downloadable-files
# entity in defaults.ent; non-English goes into a subdir in docs so we
# need to allow for that
ifeq ($(INSTALLSTYLE),subdir)
ifeq ($(LINGUA),C)
	echo "<!entity path-to-top-level \"../\">" >> $@
else
	echo "<!entity path-to-top-level \"../../\">" >> $@
endif
else
	echo "<!entity path-to-top-level \"\">" >> $@
endif
endif

.PHONY: dynamic.ent
dynamic.ent:	dynamic_$(LINGUA)_$(architecture).ent
	rm -f $@
	ln -s $< $@

# in case LINGUA isn't set, give a decent err message
$(DBOOTSTRAP_DIR)/po/.po:
	@$(checklingua)

# unlike its translations, C.po isn't static, it's autogenerated
$(DBOOTSTRAP_DIR)/po/C.po:
	$(MAKE) -C $(DBOOTSTRAP_DIR)/po C.po
