=== mips-specials/Makefile ===
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file copyright in the debian subdirectory of this archive
# for more details.
#
# Copyright (C) 2001 by Guido Guenther
#
# this is based on the arch/mips/boot/Makefile in the kernel sources

CC := gcc
CFLAGS := -Wall -Werror -pipe -O2

addinitrd: addinitrd.c
	$(CC) -o $@ $^

clean:
	rm -f addinitrd
