=== debian/changelog ===
boot-floppies (3.0.22) unstable; urgency=low

  * Adam Di Carlo:
    - documentation updates & link corrections; i386 references to  ide
      flavor removed, bf2.4 added; sparc references to removed sun4dm-pci
      subarch removed
    - fix broken docs/*fdisk.txt which are generated from man pages;
      closes: #137570
    - fix build-depends-indep-without-arch-indep
    - review all the stuff in docs/defaults.ent relating to images,
      flavors, files, etc.  There were a number of missing stuff relevant
      to lart, subarches mentioned which no longer exists, etc.
      closes: #138591, #138588, #138594
    - doc: i386 supports tftp
  * Eduard Bloch
    - fixed filesystem choice while creating of the boot-floppies on i386
    - German translation updates
    - bootconfig.c corrections to work on ATARAID
    - changed extract_base's progress box to not tell users to debug
    - changed syslinux.cfg template to work properly with non-linux.bin
      profiles, replaced linux.bin references in the messages files.
      Closes:#139786, #140264
    - PERL_BADLANG=0 before extract_base, suppress the locale warnings,
      closes: #138468
    - added USB modules to root floppy on bf2.4, closes: #139595
  * Chris Tillman
    - added note about vc4 usage in rescue-boot.sgml
    - use fdisk references in defaults.ent, not urls.ent
    - fix mipsel handling of driver floppies (copied mips code)
    - fix defaults.ent problems
    - update docs for new-powermac
    - add list of verbose/quiet effects to appendix
    - add test for Release file before calling debootstrap, 
      Closes: #132838, #136639
    - update install manual for m68k, arm
    - add table of task sizes in appendix
    - correct newpmac kernel build 1440->2880, causing name confusion
  * Giuseppe Sacco
    - corrected a small problem when identifing the installed locale
  * Mikhail Sobolev
    - Change Apple_Bootstrap messages to avoid redundancy
  * David Kimdon
    - fix French language chooser text
    - fix proxy line for server select box, better formatting when strings
      are different lengths
    - if we try a proxy, find that it doesn't work, then end up
      installing the base system without a proxy we need to set 
      [HTTP|FTP]_PROXY='' in dbootstrap_settings
    - mkreiserfs option changed from -v[1|2] to --format [3.5|3.6] 
      (closes: #139415)
    - remove scripts/rootdisk/messages/[C,ca ... zh_TW]/boot_message since we
      now hold that text in dbootstrap's .po files.
    - add note to translators that they should use only ASCII chars in the
      text to be displayed on the syslinux screen. (closes: #138849)
    - note to translators to keep bootconfig.c MBR messages under one line
      or about 70 characters. (closes: #138679)
    - require bogl-bterm 0.1.9-1 so we get pretty borders on i18n boxes,
      include some graphic fonts, patch from pb (closes: #138653)
  * Tommi Virtanen <tv@debian.org>
    - update swedish.src
  *  Alejandro Lamas <azeta@enterate.org>
    - update spanish.src
  * Junichi Uekawa
    - fs_type_tab[] should be extern (closes: #137748)
    - update dbootstrap Japanese translation
    - make dbootstrap/langs/japanese.src to be shorter
    - config: use ja, instead of pl on the basic floppy set. It should be
      okay, CDROM should have the language.
  * Petter Reinholdtsen
    - updated LC menu entry for Norwegian (applied by blade)
  * Claus Hindsgaul
    - Danish updates
    - Chinese zh_CN.po update thanks to malix <malixren@yahoo.com>
  * Karsten Merker
    - release.sh: remove garbage (side effect of the linux -> linux.bin
      transition) in $release for mipsel
    - documentation/da/inst-methods.sgml: fixed sgml error
  * Ren Weili
    - Chinese translation updates
  * Matt Kraai
    - avoid segfault during `Initialize a Linux Partition' on powerpc/apus;
      closes: #138799
    - look for netwinder rescue image in images-2.88;
      closes: #139041
  * Jordi Mallach
    - dbootstrap Catalan translation updates
    - Catalan manual and release-notes updates
    - release-notes Catalan translation by Ivan Vilata i Balaguer
    - updates to the Catalan install manual by Antoni Bella
  * Richard Hirst
    - ia64: warn if someone tries to manipulate a GPT partitioned disk
      with cfdisk
    - default fs_type to auto for any arch that doesn't explicitly specify
      it in write_boot_floppy()
    - ia64: add documentation for parted
  * Josip Rodin
    - update croatian.src
  * Colin Walters
    - bump new-powermac kernel version to 2.4.18
    - Minor english fixes in dbootstrap.
  * Steve Langasek <vorlon@debian.org>
    - update czech.src
  * Andreas Wst <andiw@pop.agri.ch>
    - update release_notes.de (closes: #140700)

 -- Adam Di Carlo <aph@debian.org>  Fri, 15 Mar 2002 01:18:26 -0500

boot-floppies (3.0.21) unstable; urgency=medium

  * Adam Di Carlo
    - we now build against Woody

      THIS IS A SERIOUS CHANGE but required for Woody release.
      If packages from unstable are needed, you will need to copy those to
      localdir as configured in `config'

    - sparc uses libc 2.2.5 now
    - sparc/sun4u kernel uses 2.4.18 (thanks BenC)
    - sparc doesn't have sun4dm-pci anymore, no one needs it (thanks BenC)
    - EXTRACT-i18n was pulling in for all arches cfdisk-utf8, which would
      break sparc build
    - package searching in 'archive' dir (where downloads go) is sensitive
      to the current architecture, making it safe to share the download dir
      for multiple arch builds if desired
  * Giuseppe Sacco
    - new maintainer for the italian translation
    - updated scripts/rescue/messages/it/*
    - updated utilities/dbootstrap/po/it.po
    - translated README-Users.it.m4
  * Richard Hirst
    - fix inverted test on USE_LANGUAGE_CHOOSER in rootdisk.sh
    - ia64: turn on USE_LANGUAGE_CHOOSER
    - ia64: move vars from make/ia64.rules to make/ia64.vars
    - boxes.c, remove redundant cast, caused gcc warning on 64 bit

