=== debian/control ===
Source: boot-floppies
Section: devel
Priority: extra
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Adam Di Carlo <aph@debian.org>, David Kimdon <dwhedon@debian.org>
Standards-Version: 3.1.1
Build-Depends: glibc-pic, slang1-pic (>= 1.4.4-7.2) | slang1-utf8-pic (>= 1.4.4-7.2), libnewt-dev (>= 0.50.17-9.4) | libnewt-utf8-dev (>= 0.50.17-9.4), libnewt-pic (>= 0.50.17-9.4) | libnewt-utf8-pic (>= 0.50.17-9.4), libpopt-dev, zlib1g-dev, recode, gettext, m4, debiandoc-sgml (>= 1.1.53), libi18n-langtags-perl, man-db, libpaperg, tetex-extra, perl5, libwww-perl, locales [i386 arm powerpc alpha], libpng2-dev [i386 arm powerpc alpha], pointerize, libgd-dev, bogl-bterm [i386 arm powerpc alpha], libbogl-dev (>= 0.1.8-1), bison, ash, dpkg-awk, flex, file, debhelper, gawk, python-dev (>= 2.1.1-4), python2.1-xml (>= 0.7-1), bf-utf-source, zlib-bin [i386 arm], dosfstools [powerpc alpha m68k], console-common [arm], vmelilo [m68k], s390-tools [s390], aboot [alpha], wget, kernel-source-2.2.20 [alpha], syslinux [i386], debootstrap, catsboot [arm], zip [arm], bzip2 [powerpc], mips-tools [mips mipsel], makedev (>= 2.3.1-58)

Package: install-doc
Section: doc
Architecture: any
Recommends: www-browser
Description: Documentation for Debian installation and release notes
 Contains documentation for the Debian installation system for this
 architecture.  Files are provided in HTML, ASCII, and PDF format in
 /usr/share/doc/install-doc.  A number of different languages are
 provided.
 .
 The full set of this this information may be found in 
   <URL:http://www.debian.org/releases/>
